dnl
dnl Few functions from pth's setup
dnl

dnl ##  configure.in:
dnl ##    AC_CHECK_TYPEDEF(<typedef>, <header>)
dnl ##  acconfig.h:
dnl ##    #undef HAVE_<typedef>
dnl ##

AC_DEFUN(AC_CHECK_TYPEDEF,[dnl
AC_REQUIRE([AC_HEADER_STDC])dnl
AC_MSG_CHECKING(for typedef $1)
AC_CACHE_VAL(ac_cv_typedef_$1,
[AC_EGREP_CPP(dnl
changequote(<<,>>)dnl
<<(^|[^a-zA-Z_0-9])$1[^a-zA-Z_0-9]>>dnl
changequote([,]), [
#include <$2>
], ac_cv_typedef_$1=yes, ac_cv_typedef_$1=no)])dnl
AC_MSG_RESULT($ac_cv_typedef_$1)
if test $ac_cv_typedef_$1 = yes; then
    AC_DEFINE(HAVE_[]translit($1, [a-z], [A-Z]))
fi
])

dnl ##
dnl ##  Check for an ANSI C struct attribute in a structure defined in a header
dnl ##
dnl ##  configure.in:
dnl ##    AC_CHECK_STRUCTATTR(<attr>, <struct>, <header>)
dnl ##  acconfig.h:
dnl ##    #undef HAVE_<attr>
dnl ##

AC_DEFUN(AC_CHECK_STRUCTATTR,[dnl
AC_REQUIRE([AC_HEADER_STDC])dnl
AC_MSG_CHECKING(for attribute $1 in struct $2 from $3)
AC_CACHE_VAL(ac_cv_structattr_$1,[dnl

AC_TRY_LINK([
#include <sys/types.h>
#include <$3>
],[
struct $2 *sp1;
struct $2 *sp2;
sp1->$1 = sp2->$1;
], ac_cv_structattr_$1=yes, ac_cv_structattr_$1=no)])dnl
AC_MSG_RESULT($ac_cv_structattr_$1)
if test $ac_cv_structattr_$1 = yes; then
    AC_DEFINE(HAVE_[]translit($1, [a-z], [A-Z]))
fi
])

dnl ##
dnl ##  Check for argument type of a function
dnl ##
dnl ##  configure.in:
dnl ##    AC_CHECK_ARGTYPE(<header> [...], <func>, <arg-number>,
dnl ##                     <max-arg-number>, <action-with-${ac_type}>)
dnl ##

AC_DEFUN(AC_CHECK_ARGTYPE,[dnl
AC_REQUIRE_CPP()dnl
AC_MSG_CHECKING([for type of argument $3 for $2()])
AC_CACHE_VAL([ac_cv_argtype_$2$3],[
cat >conftest.$ac_ext <<EOF
[#]line __oline__ "configure"
#include "confdefs.h"
EOF
for ifile in $1; do
    echo "#include <$ifile>" >>conftest.$ac_ext
done
gpat=''
spat=''
i=1
changequote(, )dnl
while test $i -le $4; do
    gpat="$gpat[^,]*"
    if test $i -eq $3; then
        spat="$spat\\([^,]*\\)"
    else
        spat="$spat[^,]*"
    fi
    if test $i -lt $4; then
        gpat="$gpat,"
        spat="$spat,"
    fi
    i=`expr $i + 1`
done
(eval "$ac_cpp conftest.$ac_ext") 2>&AC_FD_CC |\
sed -e ':join' \
    -e '/,[ 	]*$/N' \
    -e 's/,[ 	]*\n[ 	]*/, /' \
    -e 'tjoin' |\
egrep "[^a-zA-Z0-9_]$2[ 	]*\\($gpat\\)" | head -1 |\
sed -e "s/.*[^a-zA-Z0-9_]$2[ 	]*($spat).*/\\1/" \
    -e 's/(\*[a-zA-Z_][a-zA-Z_0-9]*)/(*)/' \
    -e 's/^[ 	]*//' -e 's/[ 	]*$//' \
    -e 's/^/arg:/' \
    -e 's/^arg:\([^ 	]*\)$/type:\1/' \
    -e 's/^arg:\(.*_t\)*$/type:\1/' \
    -e 's/^arg:\(.*\*\)$/type:\1/' \
    -e 's/^arg:\(.*[ 	]\*\)[_a-zA-Z][_a-zA-Z0-9]*$/type:\1/' \
    -e 's/^arg:\(.*[ 	]char\)$/type:\1/' \
    -e 's/^arg:\(.*[ 	]short\)$/type:\1/' \
    -e 's/^arg:\(.*[ 	]int\)$/type:\1/' \
    -e 's/^arg:\(.*[ 	]long\)$/type:\1/' \
    -e 's/^arg:\(.*[ 	]float\)$/type:\1/' \
    -e 's/^arg:\(.*[ 	]double\)$/type:\1/' \
    -e 's/^arg:\(.*[ 	]unsigned\)$/type:\1/' \
    -e 's/^arg:\(.*[ 	]signed\)$/type:\1/' \
    -e 's/^arg:\(.*struct[ 	][_a-zA-Z][_a-zA-Z0-9]*\)$/type:\1/' \
    -e 's/^arg:\(.*\)[ 	]_[_a-zA-Z0-9]*$/type:\1/' \
    -e 's/^arg:\(.*\)[ 	]\([^ 	]*\)$/type:\1/' \
    -e 's/^type://' >conftest.output
ac_cv_argtype_$2$3=`cat conftest.output`
changequote([, ])dnl
rm -f conftest*
])
AC_MSG_RESULT([$ac_cv_argtype_$2$3])
ac_type="$ac_cv_argtype_$2$3"
[$5]
])

dnl
dnl MOD_SETUP - Create a valid module environment
dnl
AC_DEFUN([MOD_SETUP],[
	AC_MSG_CHECKING([for current modules list])
	if test -f modules-current.list; then
		AC_MSG_RESULT(found)
	else
		cp modules.list modules-current.list
		AC_MSG_RESULT(created)
	fi

	AC_MSG_CHECKING([for all static])
	AC_ARG_ENABLE([all-static],
[  --enable-all-static     Make all modules compile statically],[
	for fil in `cat modules-current.list`;
	do
		mod_name=`echo "$fil" | sed 's/\(.*\)-\(.*\)-\(.*\)/\1/'`
		MOD_SET_COMP($mod_name,static)
	done
	AC_MSG_RESULT([yes])
])
	AC_MSG_RESULT([no])
])

dnl
dnl MOD_SET_COMP - Set a module to a certain type, usually dso or static
dnl      1)  Module name
dnl      2)  How to compile (dso,static)
dnl
AC_DEFUN([MOD_SET_COMP],[
	fil_list=`cat modules-current.list`
	rm modules-current.list
	touch modules-current.list
	for fil in $fil_list;
	do
		mod_name=`echo "$fil" | sed 's/\(.*\)-\(.*\)-\(.*\)/\1/'`
		mod_type=`echo "$fil" | sed 's/\(.*\)-\(.*\)-\(.*\)/\2/'`
		mod_comp=`echo "$fil" | sed 's/\(.*\)-\(.*\)-\(.*\)/\3/'`
		if test x$mod_name = x$1; then
			echo "$mod_name-$mod_type-$2" >> modules-current.list;
		else
			echo "$mod_name-$mod_type-$mod_comp" >> modules-current.list
		fi
	done
])

dnl
dnl MOD_GEN - Generate build variables
dnl
AC_DEFUN([MOD_GEN],[
	AC_SUBST(MOD_DSOS)
	AC_SUBST(MOD_STATICS)
	AC_SUBST(MOD_STSRC)
	AC_SUBST(MOD_FUNCS)
	fil_list=`cat modules-current.list`
	for fil in $fil_list;
	do
		mod_name=`echo "$fil" | sed 's/\(.*\)-\(.*\)-\(.*\)/\1/'`
		mod_type=`echo "$fil" | sed 's/\(.*\)-\(.*\)-\(.*\)/\2/'`
		mod_comp=`echo "$fil" | sed 's/\(.*\)-\(.*\)-\(.*\)/\3/'`
		if test x$mod_type = xmodule; then
			if test x$mod_comp = xstatic; then
				MOD_STATICS=" modules/mod_$mod_name.o $MOD_STATICS"
				MOD_STSRC=" mod_$mod_name $MOD_STSRC"
				MOD_FUNCS="mod_$mod_name(); $MOD_FUNCS "
			else
				MOD_DSOS=" mod_$mod_name.so $MOD_DSOS"
			fi
		fi
	done
])


dnl
dnl AC_CHECK_SOCKLENTYPE from pth-1.3.5
dnl
AC_DEFUN(AC_CHECK_SOCKLENTYPE,[dnl
AC_CHECK_TYPEDEF(socklen_t, sys/socket.h)
AC_CHECK_ARGTYPE(sys/types.h sys/socket.h, accept, 3, 3, [:])
AC_MSG_CHECKING(for fallback socklen_t)
AC_CACHE_VAL(ac_cv_check_socklentype, [
if test ".$ac_cv_typedef_socklen_t" = .yes; then
	ac_cv_check_socklentype='socklen_t'
elif test ".$ac_type" != .; then
	ac_cv_check_socklentype=`echo "$ac_type" | sed -e 's/[ 	]*\*$//'`
else
	ac_cv_check_socklentype='int'
fi
])
AC_MSG_RESULT([$ac_cv_check_socklentype])
ac_type="$ac_cv_check_socklentype"
ifelse([$1], , :, [$1])
])
