#include "mux.h"

/* process a sexy struct we got off the mux tstream */
void mux_read_process(mux_t mux, sexy_t sexy, void *data, int size)
{
    thread t;

    log_debug(ZONE,"processing sexy %X type %d fd %d size %d XS %X",sexy, sexy->type, sexy->fd, sexy->size, sexy->xs);

    /* how sexy is our packet? */
    switch(sexy->type)
    {
    case SEXY_NEW:
        /* a new connection was made, inc out conns count */
        /* create our xmlstream and send SEXY_SET with it's pointer as ->xs */
        mux->conns++;
        t = mux_stream_new(mux, sexy->fd, (xmlstream_onNode)mux_client_filter);
        mux_write(SEXY_SET, t, NULL, 0);
        break;
    case SEXY_READ:
        /* process data inside our xmlstream */
        mux->in++;
        mux_stream((thread)(sexy->xs), data, size);
        break;
    case SEXY_ERROR:
        /* kill the xmlstream pool, it cleans itself up */
        /* one of our conns has an error, kill it */
        mux->conns--;
        thread_free((thread)(sexy->xs));
        break;
    }
}

/* called when data arrives from the polld masterfd 
 * this is data from 1-1000 clients, on the same stream
 */
void mux_read(thread t, void *data, int buffsz)
{
    tstream ts = (tstream)(t->data); /* the tsream of this mux */
    mux_t mux = (mux_t)(ts->data);   /* the mux struct in the tstream */
    void *buff;                      /* temp storage for the new buffer */
    int newsz, leftsz;               /* newsz size of new buffer and lefovers */
    sexy_t sexy;

    log_debug(ZONE,"mux %X/%d reading %d bytes",mux,mux->in,buffsz);

    /* make new buffer include leftovers, I'm sure this logic is fubard based on the 4am rule */
    /* calc the size of the new buffer (data + leftovers) */
    newsz = buffsz + (mux->buffsz - mux->cur);
    buff = malloc(newsz);
    /* copy the old data, then copy the new data into the buffer */
    memcpy(buff,mux->buff + mux->cur,mux->buffsz - mux->cur);
    memcpy(buff + (mux->buffsz - mux->cur),data,buffsz);

    /* ditch leftovers and reset */
    free(mux->buff);
    mux->buff = buff;
    mux->cur = 0;
    mux->buffsz = newsz;

    /* while there is still data left in the buffer */
    while(mux->cur < mux->buffsz)
    {
        /* figure out how much is left */
        leftsz = mux->buffsz - mux->cur;

        /* if there is enough data to fill a sexy struct */
        if(leftsz < sizeof(_sexy_t))
            break;

        /* fill it */
        sexy = (sexy_t)(mux->buff + mux->cur);
        log_debug(ZONE,"mux->cur %d/%d sexy->size %d",mux->cur,mux->buffsz,sexy->size);
        /* did we get all the data? */
        if(leftsz < sizeof(_sexy_t) + sexy->size)
            break;

        /* we've got a full pair, read and process */
        mux->cur += sizeof(_sexy_t);
        /* okay, we got our sexy struct, lets do something with it.. */
        mux_read_process(mux, sexy, mux->buff + mux->cur, sexy->size);
        mux->cur += sexy->size;
    }
}

